std::rel_ops Namespace Reference

## Functions

template<class _Tp >
bool | operator!= (const _Tp &__x, const _Tp &__y)
template<class _Tp >
bool | operator<= (const _Tp &__x, const _Tp &__y)
template<class _Tp >
bool | operator> (const _Tp &__x, const _Tp &__y)
template<class _Tp >
bool | operator>= (const _Tp &__x, const _Tp &__y)

## Detailed Description

The generated relational operators are sequestered here.

Libstdc++ headers must not use the contents of `rel_ops`. User code should also avoid them, because unconstrained function templates are too greedy and can easily cause ambiguities.

C++20 default comparisons are a better solution.

## Function Documentation

## operator!=()

template<class _Tp >

bool std::rel_ops::operator!= | ( | const _Tp & | __x,
|  | const _Tp & | __y
| ) |  |

inline

Defines `!=` for arbitrary types, in terms of `==`.

Parameters

  __x | A thing.
  __y | Another thing.

Returns
  __x != __y

This function uses `==` to determine its result.

Definition at line 88 of file stl_relops.h.

## operator<=()

template<class _Tp >

bool std::rel_ops::operator<= | ( | const _Tp & | __x,
|  | const _Tp & | __y
| ) |  |

inline

Defines `<=` for arbitrary types, in terms of `<`.

Parameters

  __x | A thing.
  __y | Another thing.

Returns
  __x <= __y

This function uses `<` to determine its result.

Definition at line 113 of file stl_relops.h.

## operator>()

template<class _Tp >

bool std::rel_ops::operator> | ( | const _Tp & | __x,
|  | const _Tp & | __y
| ) |  |

inline

Defines `>` for arbitrary types, in terms of `<`.

Parameters

  __x | A thing.
  __y | Another thing.

Returns
  __x > __y

This function uses `<` to determine its result.

Definition at line 101 of file stl_relops.h.

## operator>=()

template<class _Tp >

bool std::rel_ops::operator>= | ( | const _Tp & | __x,
|  | const _Tp & | __y
| ) |  |

inline

Defines `>=` for arbitrary types, in terms of `<`.

Parameters

  __x | A thing.
  __y | Another thing.

Returns
  __x >= __y

This function uses `<` to determine its result.

Definition at line 127 of file stl_relops.h.